image: golang:latest

variables:
  VERSION: 0.0.${CI_PIPELINE_IID}
  REPO_NAME: gitlab.com/parker.johansen/advent-of-code-2019

# The problem is that to be able to use go get, one needs to put
# the repository in the $GOPATH. So for example if your gitlab domain
# is gitlab.com, and that your repository is namespace/project, and
# the default GOPATH being /go, then you'd need to have your
# repository in /go/src/gitlab.com/namespace/project
# Thus, making a symbolic link corrects this.
before_script:
  - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
  - cd $GOPATH/src/$REPO_NAME

stages:
  - test
  - build
  - deploy

format:
  stage: test
  script:
    - go fmt $(go list ./... | grep -v /vendor/)
    - go vet $(go list ./... | grep -v /vendor/)

test:
  stage: test
  script:
    - go test -race $(go list ./... | grep -v /vendor/)


build:
  stage: build
  script:
    - go build -race -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/aoc $CI_PROJECT_DIR/cmd/aoc/main.go
  artifacts:
    name: advent-of-code-${VERSION}
    paths:
      - aoc
